import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { BookingOrder, BookingOrderParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageBookingOrder(params: BookingOrderParam) {
  const res = await request.get<ApiResult<PageResult<BookingOrder>>>(
    MODULES_API_URL + '/booking/booking-order/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listBookingOrder(params?: BookingOrderParam) {
  const res = await request.get<ApiResult<BookingOrder[]>>(
    MODULES_API_URL + '/booking/booking-order',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addBookingOrder(data: BookingOrder) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateBookingOrder(data: BookingOrder) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-order',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeBookingOrder(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-order/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchBookingOrder(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/booking/booking-order/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getBookingOrder(id: number) {
  const res = await request.get<ApiResult<BookingOrder>>(
    MODULES_API_URL + '/booking/booking-order/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
